#!/usr/bin/env python
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# This file is in the public domain
### END LICENSE

###################### DO NOT TOUCH THIS (HEAD TO THE SECOND PART) ######################

import os
import sys

try:
    import DistUtilsExtra.auto
except ImportError:
    print >> sys.stderr, 'To build accomplishments-daemon you need https://launchpad.net/python-distutils-extra'
    sys.exit(1)
assert DistUtilsExtra.auto.__version__ >= '2.18', 'needs DistUtilsExtra.auto >= 2.18'

def update_config(values = {}):

    oldvalues = {}
    try:
        fin = file('accomplishments/accomplishments_daemonconfig.py', 'r')
        fout = file(fin.name + '.new', 'w')

        for line in fin:
            fields = line.split(' = ') # Separate variable from value
            if fields[0] in values:
                oldvalues[fields[0]] = fields[1].strip()
                line = "%s = %s\n" % (fields[0], values[fields[0]])
            fout.write(line)

        fout.flush()
        fout.close()
        fin.close()
        os.rename(fout.name, fin.name)
    except (OSError, IOError), e:
        print ("ERROR: Can't find accomplishments_daemon/accomplishments_daemonconfig.py")
        sys.exit(1)
    return oldvalues


class InstallAndUpdateDataDirectory(DistUtilsExtra.auto.install_auto):
    def run(self):
        values = {'__accomplishments_daemon_data_directory__': "'%s'" % (self.prefix + '/share/accomplishments-daemon/'),
                  '__version__': "'%s'" % (self.distribution.get_version())}
        previous_values = update_config(values)
        DistUtilsExtra.auto.install_auto.run(self)
        update_config(previous_values)


        
##################################################################################
###################### YOU SHOULD MODIFY ONLY WHAT IS BELOW ######################
##################################################################################
DistUtilsExtra.auto.setup(
    name='accomplishments-daemon',
    version='0.1',
    license='GPL-3',
    author='Jono Bacon',
    author_email='jono@ubuntu.com',
    description='Background daemon for running the Ubuntu Accomplishments system.',
    long_description='This is the background daemon process that is required to run the Ubuntu Accomplishments system.',

    url='https://launchpad.net/ubuntu-accomplishments-daemon',
    cmdclass={'install': InstallAndUpdateDataDirectory},
    data_files=[('share/accomplishments-daemon', ['data/daemon/validation-key.pub'])]
)
